Dim namefromlist, searchname
Dim authorname
Dim address, filename
Dim LISTPATH
LISTPATH=inputbox("Please enter the path for the faculty list","Provide faculty list","newsearchname.csv")
Dim HOMEDIR
HOMEDIR=inputbox("Please enter the directory of saved webpages:","Webpage Directory","webpages/")

set fs=createobject("scripting.filesystemobject")
set namelist=fs.opentextfile(LISTPATH,1,true)
Set parseddata=fs.OpenTextFile("parseddata.csv",2,True)
parseddata.writeline("""SearchedName"",""RankonPage"",""PaperDisplayed"",""TotalPaper"",""booklabel"",""NumAuthors"",""NumCitations"",""YearPublished"",""title"",""link""")


do while namelist.atendofstream<>True
namefromlist=namelist.ReadLine
searchname=Mid(namefromlist,1,Len(namefromlist))


        
        
filename = HOMEDIR & searchname & ".htm"
Set savedwebpage=fs.OpenTextFile(filename,1,True)
webpagetxt=savedwebpage.ReadAll
ParseWebpage(webpagetxt)
savedwebpage.Close
Loop

parseddata.Close






'General function to parse out segments as given by start and end tags
Function findSubStr(txt , startTag, endTag)   'do not declare function. do not set variable type.
	Dim length
	Dim position
	length = LEN(startTag)
	position = Instr(txt, startTag) + length
    If Instr(position, txt, endTag) - position>0 then
	findSubStr=Mid(txt, position, Instr(position, txt, endTag) - position)  'use function name to return output.
    Else
    findSubStr=Mid(txt, position)
    End If
end Function

Function findSubStrTag(txt , tag)
	findSubStrTag=findSubStr(txt, tag, tag)
End Function

'Function to count commas in authors list and return number of authors - 1
Function countCommas(txt2)
	Dim index
	index = Instr(txt2, ",")
	If (index = 0) Then
		countCommas=0
	Else
		countCommas=1 + countCommas(Mid(txt2, index+1))
	End If
End Function



Sub ParseWebpage(txt)

	' define some variables used in processing
	Dim quote, quote2, numAuthors, i, count, gcount, filehandle, hlinkstart, booklabel
	Dim  maxauthors, j
	Dim  author, block, leftovertxt, ahref, title, resultsnum, hlink
	Dim authors, temp, temp2, citations, longfilename


	' Parameter maxauthors determines the number of authors printed in the output datafile.

        maxauthors=10

	author = findSubStr(txt, "author:&quot;", "&quot;")
	
        if len(author) = 0 Or len(author) > 50 Then
             parseddata.writeline(author)
	        author=Mid(txt,Instr(txt,"author:")+1,30)
                parseddata.writeline("Warning: Probable Author Error")
                             parseddata.writeline(author)
        End If


	    resultsnum = findSubStr(txt, "Results <b>1</b> - <b>", "</b>")
	    resultstotalnum=findSubStr(txt,"</b> of about <b>","</b>")
	    If Not Len(resultstotalnum)<7 Then
	    resultstotalnum=findSubStr(txt,"</b> of <b>","</b>")
	    End If
	    If IsNumeric(resultsnum)  Then
        gcount = resultsnum ' no val is availale in VBS as all variables are of type variant.
        If Len(resultstotalnum)<7 Then
        gtotalcount=resultstotalnum
        
        End If
        Else
        gcount=0
        gtotalcount=0
        parseddata.WriteLine(""""&searchname&""","""&"0"&""","""&gcount&""","""&gtotalcount&""",""no result""")
        End If


	count = 1





	block = findSubStrTag(txt, "<div class=""gs_r""><h3 class=""gs_rt"">")
	
   	leftovertxt = Mid(txt&"a", InStr(txt, block)+LEN(block))

        If Instr(block,"User profiles for <b>author:&quot;") <> 0 Then

           block = findSubStrTag(leftovertxt,"<div class=""gs_r""><h3 class=""gs_rt"">")
	   leftovertxt = Mid(leftovertxt&"a", InStr(leftovertxt, block)+LEN(block))

        End If



        	Do While  (LEN(block) <> 0) AND (count <=gcount*1)



        	
        	parseddata.Write(""""&searchname&""","""&count&""","""&gcount&""","""&gtotalcount)
        	
    
        booklabel = 0
        
        If Instr(block,"<span class=""gs_ctc"">[BOOK]</span>") <> 0 Then booklabel = 1

    hlinkstart = Instr(block, "<a href")

                If hlinkstart > 0 And hlinkstart < 40 Then
			hlink = findSubstr(block,"<a href=""","""")
                        block = Mid(block, hlinkstart+1)
                    	title = findSubstr(block, ">", "</a>")
			If Instr(block,"[BOOK]") <> 0 Then
			title = "[BOOK]" & title
			End If
			Else
			title = findsubstr(block, "</span>", "</h3>")
                        if Instr(block,"[CITATION]") = 0 Then
                          hlink="Warning. No hyperlink to title and no [CITATION]"
                        End If
                End If

                If title = "" Then
                	hlink=block
                End If


            If DEBUGORNOT Then parseddata.writeline(finaloutput(count)&"<br />")

		temp = findSubstr(block, "<div class=""gs_a"">","</div>")        		
                temp2 = findSubstr(block, "<div class=""gs_a"">"," -")

		If LEN(temp) > LEN(temp2) Then
			authors = temp2
			yeartemp1=findSubStr(block,authors&" -","</div>")
			yeartemp2=findSubStr(block,authors&" -"," -")
			If Len(yeartemp1)>Len(yeartemp2) Then
			paperyear=yeartemp2
			Else
			paperyear=yeartemp1
			End If
			paperyear=Right(paperyear,4)
			If Not IsNumeric(paperyear) Then
			paperyear=Null
			End If					
		Else
			authors = temp
			paperyear=null
		End if

		numAuthors = 1
		i = LEN(authors)
		numAuthors = countCommas(authors) + 1
		If InStr(authors,"&hellip;")<>0 Or InStr(InStr(authors,"&hellip;")+8,authors,"&hellip;")>0 Then
		numAuthors = numAuthors + 1
		End If
		

        If DEBUGORNOT Then parseddata.writeline(authors&"<br />"&numauthors&"<br />")

		If numAuthors > maxauthors Then
                	parseddata.writeline("Error: Too Many authors. Numauthors, maxauthors = " & numauthors & maxauthors )
			        exit do
                End if

		If Instr(block, "Cited by") > 0 Then
			citations = findSubstr(block, "Cited by", "</a>")
                        if Not IsNumeric(citations) then   ' val no longer available. Use IsNumeric to confirm variable type.
                        citations="-1"
                        End if
		Else
	                  citations = "0"
                ENd if

        If DEBUGORNOT Then    parseddata.write(citations&"<br />")
        
        
        parseddata.writeline(""","""&booklabel&""","""&numAuthors&""","""&citations&""","""&paperyear&""","""&title&""","""&hlink&"""")

        count = count + 1

    	block = findSubStrTag(leftovertxt,"<div class=""gs_r""><h3 class=""gs_rt"">")
'MsgBox(block)
'MsgBox(leftovertxt)
		leftovertxt = Mid(leftovertxt&"a", InStr(leftovertxt, block)+LEN(block))
		
        Loop

End Sub
